      PARAMETER ( MP=10, MG=10, NJMAX=50 )                              
      IMPLICIT REAL*8 (A-H,O-Z)                                         
      DIMENSION E(MP),G(MP,MG),ALFA(50),X(MP),G0(MP,MG),E0(MP),IPW(50), 
     .   LST(NJMAX),IJOUT(NJMAX)                                        
      CHARACTER*60 ID(NJMAX),ID0,INFILE
      COMMON ALFA,IPW,NG                                                
	PRINT*,'INPFILE?'
	READ(5,1010)INFILE
1010	FORMAT(A)
	OPEN(10,FILE=INFILE,STATUS='OLD')
      IFI=6                                                             
C ----- SET UP LIST OF JOBS IN FILE ---------                           
      NJ=0                                                              
      L=0                                                               
  90  L=L+1	
      READ(10,900,END=91) ID0                                           
  900 FORMAT(A60)                                                       
      IF(ID0(1:2).EQ.'--') THEN                                         
        NJ=NJ+1                                                         
        LST(NJ)=L                                                       
        IF(NJ.GT.NJMAX) STOP '**** INCREASE NJMAX IN MLSQ'              
        ID(NJ)=ID0                                                      
        ENDIF                                                           
      GOTO 90                                                           
  91  CONTINUE                                                          
      IF(NJ.EQ.1) THEN                                                  
        IJOUT(1)=1                                                      
        IJOUT(2)=-1                                                     
        GOTO 97                                                         
        ENDIF                                                           
C ------- SELECT PARTS OF FILE ----------                               
  92  CONTINUE                                                          
      DO 40 IJ=1,NJ                                                     
  40  WRITE(6,401) IJ,ID(IJ)                                            
  401 FORMAT(I5,2X,A60)                                                 
  95  CONTINUE                                                          
      DO 47 I=1,NJMAX                                                   
  47  IJOUT(I)=-1                                                       
      WRITE(6,*) 'ENTER NUMS/, 0/ FOR ALL, -2/ FOR LIST, / TO STOP,',   
     .  '-3/ FOR FILE'                                                  
      READ (5,*)  IJOUT                                                 
      IF(IJOUT(1).EQ.-2) GOTO 92                                        
      IF(IJOUT(1).EQ.-3) THEN
	PRINT*,'OUTFILE?'
	READ(5,1010)INFILE
	OPEN(9,FILE=INFILE,STATUS='NEW')
	IFI=9
	GOTO95
	ENDIF                                          
      IF(IJOUT(1).EQ.-1) STOP                                           
      IF(IJOUT(1).EQ.0) THEN                                            
        DO 46 I=1,NJ                                                    
  46    IJOUT(I)=I                                                      
        ENDIF                                                          
  97  CONTINUE                                                         
      DO 49 J=1,NJMAX                                                  
      IJ=IJOUT(J)                                                      
      IF(J.EQ.2.AND.NJ.EQ.1) STOP                                      
      IF(IJ.EQ.-1) GOTO 95                                             
      REWIND 10                                                         
      DO 43 L=1,LST(IJ)                                                 
  43  READ(10,430)                                                      
  430 FORMAT(1X)                                                        
      WRITE(IFI,440) ID(IJ)                                             
  440 FORMAT(/1X,A60)                                                   
C ------- READ IN DATA -------                                          
      READ(10,*) NG,(IPW(IG),IG=1,NG)
      READ(10,*) NP 
      DO 8 IP=1,NP                                                      
  8   READ(10,*) X(IP),E(IP)                                            
      IF(NP.GT.MP.OR.NG.GT.MG) STOP '*** INCREASE DIMENSIONS'           
      READ(10,*) XMIN,XMAX,DX,XEXP                                      
C ------ SET UP FIT FUNCTIONS G ------                                  
      DO 1 IG=1,NG                                                      
      IPOW=IPW(IG)                                                      
      IF(IPOW.EQ.0) THEN                                                
        DO 2 IP=1,NP                                                    
  2     G(IP,IG)=1.D0                                                   
      ELSE                                                              
        DO 9 IP=1,NP                                                    
  9     G(IP,IG)=X(IP)**IPOW                                            
      ENDIF                                                             
  1   CONTINUE                                                          
C -------- SAVE INPUT AND DO FIT ----------                             
      DO 3 IP=1,NP                                                      
      E0(IP)=E(IP)                                                      
      DO 3 IG=1,NG                                                      
  3   G0(IP,IG)=G(IP,IG)                                                
      CALL LSQFIT(E,G,ALFA,NG,NP,1,MP)                                  
C ------ OUTPUT ----------------                                        
      WRITE(IFI,104) (IPW(IG),IG=1,NG)                                  
      WRITE(IFI,100) (ALFA(I),I=1,NG)                                   
  104 FORMAT(' POWERS:',8(5X,I5,5X))    
  100 FORMAT(' COEFFS:',8(1X,G14.7))                                         
      WRITE(IFI,876)                                                    
      DO 10 IP=1,NP                                                     
      SUM=0.D0                                                          
      DO 11 IG=1,NG                                                     
  11  SUM=SUM+ALFA(IG)*G0(IP,IG)                                        
      DIF=E0(IP)-SUM                                                    
  10  WRITE(IFI,875) IP,X(IP),E0(IP),SUM,DIF                            
  875 FORMAT(I3,G14.7,3(1X,G14.7))                                           
  876 FORMAT('  IP    X   ',11X,'E0 ',9X,'   FIT',9X,'     DIF')
C ---- LOOK FOR MINIMUM ----------                                      
C|    DD=0.005                                                          
      DD=0.0001                                                         
      FLAST=FIT(XMIN)                                                   
      XX=XMIN                                                           
      NX=(XMAX-XMIN)/DX                                                 
      DO 50 IX=1,NX                                                     
      XX=XMIN+IX*DX                                                     
      FNOW=FIT(XX)                                                      
      IF(FNOW.GT.FLAST) GOTO 51                                         
  50  FLAST=FNOW                                                        
        WRITE(IFI,*) 'NO MIN FOUND BETWEEN XMIN,XMAX'                   
        GOTO 77                                                         
  51  XX=XX-DX                                                          
      WRITE(IFI,748) FIT(XX),XX,DX                                      
  748 FORMAT(' MINIMUM:  E=',G14.7,'   AT X=',G14.7,'    DX=',G14.7)     
      D2EXX=(FIT(XX+DD)-2.D0*FIT(XX)+FIT(XX-DD))/(DD*DD)                
      WRITE(IFI,795) D2EXX,XX                                           
  795 FORMAT(' D2EXX=',G14.7,'    AT ',G14.7)                            
  77  XX=XEXP                                                           
      D2EXX=(FIT(XX+DD)-2.D0*FIT(XX)+FIT(XX-DD))/(DD*DD)                
      WRITE(IFI,795) D2EXX,XX                                           
  49  CONTINUE                                                          
      END                                                               
C ------------------------------                                        
      DOUBLEPRECISION FUNCTION FIT(X)                                   
      IMPLICIT REAL*8 (A-H,O-Z)                                         
      DIMENSION ALFA(50),IPW(50)                                        
      COMMON ALFA,IPW,NG                                                
      EX=0.D0                                                           
      DO 98 IG=1,NG                                                     
      IPOW=IPW(IG)                                                      
      IF(IPOW.EQ.0) EX=EX+ALFA(IG)                                      
  98  IF(IPOW.GT.0) EX=EX+ALFA(IG)*X**IPOW                              
      FIT=EX                                                            
      RETURN                                                            
      END                                                               


      SUBROUTINE LSQFIT(U,G,ALFA,M,N,NFIT,NG)                           
C  LSQ FIT OF M VECTORS OF LENGTH N IN G TO MAKE VECTORS U,             
C  NFIT= NUMBER OF VECTORS U. OUTPUT IS COEFFS IN ALFA.                 
C  DIMENSION G AS G(NG,M) IN CALLING PROG.                              
      IMPLICIT REAL*8 (A-H,O-Z)                                         
      DIMENSION G(NG*M),ALFA(M,NFIT),U(N,NFIT)                          
      DO 1 IFIT=2,NFIT                                                  
      DO 1 NU=1,M                                                       
      INU=(NU-1)*NG                                                     
      SUM=0.D0                                                          
      DO 2 I=1,N                                                        
  2   SUM=SUM+U(I,IFIT)*G(I+INU)                                        
  1   ALFA(NU,IFIT)=SUM                                                 
                                                                        
      IC0=NG*M                                                          
      DO 10 NU=M,1,-1                                                   
      IC0=IC0-NU                                                        
      INU=(NU-1)*NG                                                     
      DO 11 MU=1,NU                                                     
      IMU=(MU-1)*NG                                                     
      SUM=0.D0                                                          
      DO 12 I=1,N                                                       
  12  SUM=SUM+G(I+INU)*G(I+IMU)                                         
  11  ALFA(MU,1)=SUM                                                    
      SUM=0.D0                                                          
      DO 13 I=1,N                                                       
  13  SUM=SUM+U(I,1)*G(I+INU)                                           
      DO 14 MU=1,NU                                                     
  14  G(IC0+MU)=ALFA(MU,1)                                              
  10  ALFA(NU,1)=SUM                                                    
      IC0=IC0+1                                                         
      CALL CHLR2F(G(IC0),U,M,MDEF)                                      
      IF(MDEF.LT.M) STOP '*** MDEF LT M IN LSQFIT'                      
      CALL CHLR2S(G(IC0),ALFA,M,NFIT)                                   
      RETURN                                                            
      END                                                               
C:FILE   CHLR2F FORTRAN HADES     F 80   RECS=31   LAST                 
      SUBROUTINE CHLR2F(C,W,N,NDEF)                                     
C CHOLESKY FACTORIZATION OF (N X N) REAL*8 MATRIX C.                    
C RETURNS AS SOON AS MATRIX BECOMES INDEFINITE, REST IS UNCHANGED       
C W=WORKSPACE OF DIMENSION N                                            
      IMPLICIT REAL*8 (A-H,O-Z)                                         
      DIMENSION C(1),W(N)                                               
      IC0=0                                                             
      DO 10 I=1,N                                                       
      JC0=0                                                             
      DO 11 J=1,I-1                                                     
      CSUM=C(IC0+J)                                                     
      DO 12 K=1,J-1                                                     
  12  CSUM=CSUM-W(K)*C(JC0+K)                                           
      JC0=JC0+J                                                         
  11  W(J)=CSUM/C(JC0)                                                  
      CSUM=C(IC0+I)                                                     
      DO 14 K=1,I-1                                                     
  14  CSUM=CSUM-W(K)*W(K)                                               
      IF(CSUM.LE.0.D0) THEN                                             
        NDEF=I-1                                                        
        GOTO 99                                                         
        ENDIF                                                           
      DO 13 J=1,I-1                                                     
  13  C(IC0+J)=W(J)                                                     
      IC0=IC0+I                                                         
  10  C(IC0)=DSQRT(CSUM)                                                
      NDEF=N                                                            
  99  IF(NDEF.LT.N) WRITE(6,230) N,NDEF                                 
  230 FORMAT(' CHLR2F:    N=',I4,'    NDEF=',I4)                        
      RETURN                                                            
      END                                                               

      SUBROUTINE CHLR2S(C,V,N,M)                                        
C BACK SUBSTITUTION AFTER CHOLESKY FACTORIZATION                        
C SOLUTION OVERWRITES RHS IN V, M=NUMBER OF RHS'S.                      
      IMPLICIT REAL*8 (A-H,O-Z)                                         
      DIMENSION C(1),V(N,M)                                             
      DO 20 MM=1,M                                                      
      IC0=0                                                             
      DO 10 I=1,N                                                       
      CSUM=V(I,MM)                                                      
      DO 11 K=1,I-1                                                     
  11  CSUM=CSUM-V(K,MM)*C(IC0+K)                                        
      IC0=IC0+I                                                         
  10  V(I,MM)=CSUM/C(IC0)                                               
                                                                        
      DO 12 I=N,1,-1                                                    
      IND2=(I*(I+1))/2                                                  
      CSUM=V(I,MM)                                                      
      IND1=IND2+I                                                       
      DO 13 K=I+1,N                                                     
      CSUM=CSUM-V(K,MM)*C(IND1)                                         
  13  IND1=IND1+K                                                       
  12  V(I,MM)=CSUM/C(IND2)                                              
  20  CONTINUE                                                          
      RETURN                                                            
      END                                                               
